#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "simulator.h"

#include "oshseed.h"
#define ASENV_SHORT_NAMES
#include "envseed.h"
#define SC ASOSH_SWITCH_CHARACTER

const char *algorithm_names[ALG_NUM_ALGS]={
		"indep_random",
		"indep_weighted_random_Puu",
		"indep_weighted_random_Puuw",
		"indep_weighted_random_Pfanny",
		"indep_weighted_random_Pfannyw",
		"indep_weighted_random_PIu",
		"indep_weighted_random_PIuw",
		"indep_weighted_random_PIuf",
		"indep_weighted_random_PIufw",
		"indep_MCT_v1",
		"indep_MCT_v2",
		"indep_LW_v1",
		"indep_LW_v2",
		"indep_UD_v1",
		"indep_UD_v2",
		"indep_RATE_v1",
		"indep_RATE_v2",
		"indep_EMCT_v1",
		"indep_EMCT_v2",
		"indep_ELW_v1",
		"indep_ELW_v2",
		"indep_EUD_v1",
		"indep_EUD_v2",
		"indep_ERATE_v1",
		"indep_ERATE_v2",
		"indep_ENCRATE_v1",
		"indep_ENCRATE_v2",
		"indep_ENCRATENAIVE_v1",
		"indep_ENCRATENAIVE_v2",
                "coupled_random",
                "coupled_weighted_random_Puu",
                "coupled_weighted_random_Puuw",
                "coupled_weighted_random_Pfanny",
                "coupled_weighted_random_Pfannyw",
                "coupled_weighted_random_PIu",
                "coupled_weighted_random_PIuw",
                "coupled_weighted_random_PIuf",
                "coupled_weighted_random_PIufw",
                "coupled_MCT_v1",
                "coupled_MCT_v2",
                "coupled_LW_v1",
                "coupled_LW_v2",
                "coupled_UD_v1",
                "coupled_UD_v2",
                "coupled_EMCT_v1",
                "coupled_EMCT_v2",
                "coupled_ELW_v1",
                "coupled_ELW_v2",
                "coupled_EUD_v1",
                "coupled_EUD_v2",
		"coupled_IE",
		"coupled_IP",
		"coupled_IR",
		"coupled_IY",
		"coupled_random_PP",
		"coupled_weighted_random_Puu_PP",
		"coupled_weighted_random_Puuw_PP",
		"coupled_weighted_random_Pfanny_PP",
		"coupled_weighted_random_Pfannyw_PP",
		"coupled_weighted_random_PIu_PP",
		"coupled_weighted_random_PIuw_PP",
		"coupled_weighted_random_PIuf_PP",
		"coupled_weighted_random_PIufw_PP",
		"coupled_MCT_v1_PP",
		"coupled_MCT_v2_PP",
		"coupled_LW_v1_PP",
		"coupled_LW_v2_PP",
		"coupled_UD_v1_PP",
		"coupled_UD_v2_PP",
		"coupled_EMCT_v1_PP",
		"coupled_EMCT_v2_PP",
		"coupled_ELW_v1_PP",
		"coupled_ELW_v2_PP",
		"coupled_EUD_v1_PP",
		"coupled_EUD_v2_PP",
		"coupled_IE_PP",
		"coupled_IP_PP",
		"coupled_IR_PP",
		"coupled_IY_PP",
		"coupled_random_PE",
		"coupled_weighted_random_Puu_PE",
		"coupled_weighted_random_Puuw_PE",
		"coupled_weighted_random_Pfanny_PE",
		"coupled_weighted_random_Pfannyw_PE",
		"coupled_weighted_random_PIu_PE",
		"coupled_weighted_random_PIuw_PE",
		"coupled_weighted_random_PIuf_PE",
		"coupled_weighted_random_PIufw_PE",
		"coupled_MCT_v1_PE",
		"coupled_MCT_v2_PE",
		"coupled_LW_v1_PE",
		"coupled_LW_v2_PE",
		"coupled_UD_v1_PE",
		"coupled_UD_v2_PE",
		"coupled_EMCT_v1_PE",
		"coupled_EMCT_v2_PE",
		"coupled_ELW_v1_PE",
		"coupled_ELW_v2_PE",
		"coupled_EUD_v1_PE",
		"coupled_EUD_v2_PE",
		"coupled_IE_PE",
		"coupled_IP_PE",
		"coupled_IR_PE",
		"coupled_IY_PE",
		"coupled_random_PR",
		"coupled_weighted_random_Puu_PR",
		"coupled_weighted_random_Puuw_PR",
		"coupled_weighted_random_Pfanny_PR",
		"coupled_weighted_random_Pfannyw_PR",
		"coupled_weighted_random_PIu_PR",
		"coupled_weighted_random_PIuw_PR",
		"coupled_weighted_random_PIuf_PR",
		"coupled_weighted_random_PIufw_PR",
		"coupled_MCT_v1_PR",
		"coupled_MCT_v2_PR",
		"coupled_LW_v1_PR",
		"coupled_LW_v2_PR",
		"coupled_UD_v1_PR",
		"coupled_UD_v2_PR",
		"coupled_EMCT_v1_PR",
		"coupled_EMCT_v2_PR",
		"coupled_ELW_v1_PR",
		"coupled_ELW_v2_PR",
		"coupled_EUD_v1_PR",
		"coupled_EUD_v2_PR",
		"coupled_IE_PR",
		"coupled_IP_PR",
		"coupled_IR_PR",
		"coupled_IY_PR",
		"coupled_random_PY",
		"coupled_weighted_random_Puu_PY",
		"coupled_weighted_random_Puuw_PY",
		"coupled_weighted_random_Pfanny_PY",
		"coupled_weighted_random_Pfannyw_PY",
		"coupled_weighted_random_PIu_PY",
		"coupled_weighted_random_PIuw_PY",
		"coupled_weighted_random_PIuf_PY",
		"coupled_weighted_random_PIufw_PY",
		"coupled_MCT_v1_PY",
		"coupled_MCT_v2_PY",
		"coupled_LW_v1_PY",
		"coupled_LW_v2_PY",
		"coupled_UD_v1_PY",
		"coupled_UD_v2_PY",
		"coupled_EMCT_v1_PY",
		"coupled_EMCT_v2_PY",
		"coupled_ELW_v1_PY",
		"coupled_ELW_v2_PY",
		"coupled_EUD_v1_PY",
		"coupled_EUD_v2_PY",
		"coupled_IE_PY",
		"coupled_IP_PY",
		"coupled_IR_PY",
		"coupled_IY_PY"
	};

struct global_t global;

static int parseOptions(const char * const *argv);
static void printUsage(void);
static int BadSwitchHandler(ParseErrors error,
                 const char *badWord, unsigned badSwitchOffset,
                 unsigned badSwitchLen, const char *badValue);

static int BadSwitchSeen=0;

static int instantiate_host(host_t **host, const char *host_spec);
static void print_scenario(void);
static int sanity_check(void);
static int print_simulation_output(algorithm_t alg);

/*
 * Command-line arguments
 */
int main(int argc, char **argv) 
{
  int option_status;
  int i;

  /* parse command-line arguments */
  if ((option_status = parseOptions((const char * const *)argv)) < 0) {
    if (option_status == -1)
      printUsage();
    exit(1);
  }

  /* Sanity check the settings */
  if (sanity_check()) {
    exit(1);
  }

  /* Print information on the scenario */
  print_scenario();
  
  /* run the simulation for each algorithm */
  for (i=0; i < global.num_algs; i++) {
    if (run_simulation(global.algs[i])) {
     exit(1);
    }
    if (print_simulation_output(global.algs[i])) {
      exit(1);
    }
  }

  exit(0);
}

/*********************************/
/** Command line option parsing **/
/*********************************/

/* printUsage() */
static void printUsage(void)
{
  int i;

  fprintf(stderr,"Usage: simulator [flags]\n"
                 "  [-h]                     prints usage\n"
                 "  [-v]                     verbose mode\n"
                 "  [-vv]                    ultra verbose mode\n"
                 "  (-alg  <algorithm name>)+   \n"
                 "  (-host <w#seed#length#puu#pur#pud#pru#prr#prd#pdu#pdr#pdd>)+     host(s)\n"
                 "  [-pareto <shape parameter>]          shape parameter for a Pareto semi-Markov model\n"
                 "  [-weibull <shape parameter>]         shape parameter for a Weibull semi-Markov model\n"
                 "  (-host <w#start_entry#tracefile>)+   host(s)\n"
		 "  -maxnumcomms <max num of concurrent communications>\n"
		 "  [-nonresumabledownloads]\n" 
                 "  -numtasks <num of tasks>\n"
                 "  (-numiterations <num of iterations> | -timelimit <num of times steps>)\n"
                 "  (-independent | -coupled )\n"
                 "  -clone <max num of clone per task> (default = 0)\n"
                 "  -Tprog <Tprog>\n"
                 "  -Tdata <Tdata>\n"
          );
  
  fprintf(stderr,"\n  List of algorithms:\n");
  for (i=0; i<ALG_NUM_ALGS; i++)
    fprintf(stderr,"    - %s\n",algorithm_names[i]);
  fprintf(stderr,"\n");
  fprintf(stderr,"Example trace format:\n");
  fprintf(stderr,"2 U  \t// up for 2 time steps\n");
  fprintf(stderr,"3 R  \t// reclaimed for 3 time steps\n");
  fprintf(stderr,"10 U \t// up for 10 time steps\n");
  fprintf(stderr,"23 D \t// down for 23 time steps\n");
  fprintf(stderr,"...\n");
  fprintf(stderr,"Output format:\n");
  fprintf(stderr,"  simulation:  <alg name>|<time>|<num iterations>|<availcomp>|<usedcompu>|<wastedcomp>|commsteps|commwastedsteps\n");
  return;
}

/*
 * A switch error handler.  Passed the error, the element of argv
 * that contains the bad switch, the offset into that element of the
 * switch name, the length of the switch name, and the bad value,
 * if appropriate.  
 */
static int BadSwitchHandler(ParseErrors error,
                 const char *badWord, unsigned badSwitchOffset,
                 unsigned badSwitchLen, const char *badValue) {

  int intLen = (int)badSwitchLen;

  if(error == ARGUMENTS_NOT_ALLOWED)
    fprintf(stderr, "This program takes no program arguments\n");
  else if(error == INVALID_VALUE)
    fprintf(stderr, "Error: Value '%s' is invalid for switch '%*.*s'\n",
            badValue, intLen, intLen, badWord + badSwitchOffset);
  else if(error == MISSING_VALUE)
    fprintf(stderr, "Error: Switch '%*.*s' requires a value\n",
            intLen, intLen, badWord + badSwitchOffset);
  else if(error == UNKNOWN_SWITCH)
    fprintf(stderr, "Error: '%*.*s' is not a known switch\n",
            intLen, intLen, badWord + badSwitchOffset);

  BadSwitchSeen = 1;
  return 1; /* Allow argv parsing to continue. */
}

/* Parse the options and set default values 
 *
 * returns -1 when the usage should be printed
 * returns -2 when the usage should not be printed
 * returns 0 when Ok
 */

static int parseOptions(const char * const *argv)
{
  /* Declaration of all possible options */
  const char *validSwitches =
    SC "h void                \n"
    SC "v void                \n"
    SC "vv void               \n"
    SC "alg string            \n"
    SC "host string           \n"
    SC "pareto double         \n"
    SC "weibull double        \n"
    SC "numtasks int          \n"
    SC "numiterations int     \n"
    SC "timelimit int         \n"
    SC "maxnumcomms int       \n"
    SC "nonresumabledownloads \n"
    SC "coupled void   	      \n"
    SC "independent void      \n"
    SC "Tprog int             \n"
    SC "clone int             \n"
    SC "Tdata int             \n";

  ParsedArgv pa;

  /* Check for errors */
  if ((pa = ParseArgv(argv, validSwitches,&BadSwitchHandler)) == NULL ||
      BadSwitchSeen) {
//    fprintf(stderr, "\n%s\n", validSwitches);
    return -1;
  }

  /* -h switch */
  if (SwitchPresent(pa,"-h")) {
    return -1;
  }

  if (SwitchPresent(pa,"-pareto") && SwitchPresent(pa,"-weibull")) {
    fprintf(stderr,"Only one of -pareto and -weibull flag allowed\n");
    return -1;
  }

  /* -pareto switch */
  if (SwitchPresent(pa,"-pareto")) {
    global.distribution = PARETO;
    const char *shape_string=SwitchValueN(pa,"-pareto",1,"0");
    if (*SwitchValueN(pa,"-length",2,""))
      fprintf(stderr,"Warning: multiple -pareto flags, ignoring all but the first one\n");
    sscanf(shape_string,"%lf",&(global.distribution_shape));
    if (global.distribution_shape <= 1.0) {
      fprintf(stderr,"Error: Pareto parameter must be >1\n");
      return -1;
    }
  } else if (SwitchPresent(pa,"-weibull")) { /* -weibull switch */
    global.distribution = WEIBULL;
    const char *pareto_string=SwitchValueN(pa,"-weibull",1,"0");
    if (*SwitchValueN(pa,"-length",2,""))
      fprintf(stderr,"Warning: multiple -weibull flags, ignoring all but the first one\n");
    sscanf(pareto_string,"%lf",&(global.distribution_shape));
    if (global.distribution_shape <= 0.0) {
      fprintf(stderr,"Error: Weibull parameter must be >0\n");
      return -1;
    }
  } else {
    global.distribution = MARKOV;
    global.distribution_shape = -1.0;
  }


  /* -v/vv switch */
  if (SwitchPresent(pa,"-vv")) {
    global.verbose = 2;  
  } else if (SwitchPresent(pa,"-v")) {
    global.verbose = 1;
  } else {
    global.verbose = 0;
  }

  /* -coupled/independent switch */
  if (SwitchPresent(pa,"-coupled") && SwitchPresent(pa,"-independent")) {
    fprintf(stderr,"Only one of -coupled and -independent allowed\n");
    return -2;
  } else if (SwitchPresent(pa,"-coupled")) {
    global.application.mode = MODE_COUPLED;
  } else if (SwitchPresent(pa,"-independent")) {
    global.application.mode = MODE_INDEPENDENT;
  } else {
    fprintf(stderr,"One of -coupled or -independent flags required\n");
    return -2;
  }

  /* -Tprog switch */
  if (SwitchPresent(pa,"-Tprog")) {
    const char *Tprog_string=SwitchValueN(pa,"-Tprog",1,"0");
    if (*SwitchValueN(pa,"-Tprog",2,"")) {
      fprintf(stderr,"Error: Only one -Tprog flag allowed\n");
      return -2;
    }
    sscanf(Tprog_string,"%d",&(global.application.Tprog));
    if (global.application.Tprog < 0) {
      fprintf(stderr,"Error: invalid -Tprog flag value\n");
      return -2;
    }
  } else {
    fprintf(stderr,"Error: One -Tprog flag required\n");
    return -2;
  }

  /* -Tdata switch */
  if (SwitchPresent(pa,"-Tdata")) {
    const char *Tdata_string=SwitchValueN(pa,"-Tdata",1,"0");
    if (*SwitchValueN(pa,"-Tdata",2,"")) {
      fprintf(stderr,"Error: Only one -Tdata flag allowed\n");
      return -2;
    }
    sscanf(Tdata_string,"%d",&(global.application.Tdata));
    if (global.application.Tdata < 0) {
      fprintf(stderr,"Error: invalid -Tdata flag value\n");
      return -2;
    }
  } else {
    fprintf(stderr,"Error: No -Tdata flag\n");
    return -2;
  }

  /* -numtasks switch */
  if (SwitchPresent(pa,"-numtasks")) {
    const char *numtasks_string=SwitchValueN(pa,"-numtasks",1,"0");
    if (*SwitchValueN(pa,"-numtasks",2,"")) {
      fprintf(stderr,"Error: Only one -numtasks flag allowed\n");
      return -2;
    }
    sscanf(numtasks_string,"%d",&(global.application.num_tasks));
    if (global.application.num_tasks <= 0) {
      fprintf(stderr,"Error: Invalid -numtasks value\n");
      return -2;
    }
  } else {
    fprintf(stderr,"Error: One -numtasks flag is required\n");
    return -2;
  }

  /* -clone switch */
  if (SwitchPresent(pa,"-clone")) {
    const char *clone_string=SwitchValueN(pa,"-clone",1,"0");
    if (*SwitchValueN(pa,"-clone",2,"")) {
      fprintf(stderr,"Error: Only one -clone flag allowed\n");
      return -2;
    }
    sscanf(clone_string,"%d",&(global.max_num_clones));
    if (global.max_num_clones < 0) {
      fprintf(stderr,"Error: Invalid -clone value\n");
      return -2;
    }
  } else {
    global.max_num_clones = 0;
  }

  /* -maxnumcomms switch */
  if (SwitchPresent(pa,"-maxnumcomms")) {
    const char *maxnumcomms_string=SwitchValueN(pa,"-maxnumcomms",1,"0");
    if (*SwitchValueN(pa,"-maxnumcomms",2,"")) {
      fprintf(stderr,"Error: Only one -maxnumcomms flag allowed\n");
      return -2;
    }
    sscanf(maxnumcomms_string,"%d",&(global.platform.max_num_comms));
    if (global.platform.max_num_comms <= 0) {
      fprintf(stderr,"Error: Invalid -maxnumcomms value\n");
      return -2;
    }
  } else {
    fprintf(stderr,"Error: One -maxnumcomms flag is required\n");
    return -2;
  }

  /* -nonresumabledownloads switch */
  if (SwitchPresent(pa,"-nonresumabledownloads")) {
    global.platform.nonresumabledownloads = TRUE;
  } else {
    global.platform.nonresumabledownloads = FALSE; /* default */
  }

  /* -alg switch */
  if (!SwitchPresent(pa,"-alg")) {
    fprintf(stderr,"Error: One -alg flag required\n");
    return -2;
  } else {
    int n=1;
    int i;
    int flag_all = FALSE;
    const char *alg_string;
    global.algs = NULL;
    global.num_algs = 0;
    while (*(alg_string = SwitchValueN(pa,"-alg",n,""))) {

      if (!strcmp(alg_string,"all")) {
        flag_all = TRUE;
        break;
      }

      for (i=0; i<ALG_NUM_ALGS; i++)  {
        if (!strcmp(alg_string,algorithm_names[i])) {
          global.algs = (algorithm_t *)realloc(global.algs,
                    (global.num_algs+1)*sizeof(algorithm_t));
	  global.algs[global.num_algs] = (algorithm_t)i;
 
          global.num_algs++;
          break;
        }
      }
      if (i < ALG_NUM_ALGS) {
        n++;
      } else {
        fprintf(stderr,"Error: algorithm '%s' unknown\n",alg_string);
        int j;
        for (j=0; j<ALG_NUM_ALGS; j++)  {
          fprintf(stderr,"\t- %s\n",algorithm_names[j]);
        }
        return -2;
      }
    }
    /* What the 'all' flag specified? */
    if (flag_all) {
      if (global.algs) {
        free(global.algs);
      }
      global.algs = (algorithm_t *)calloc((int)ALG_NUM_ALGS,sizeof(algorithm_t));
      global.num_algs = (int)ALG_NUM_ALGS;
      for (i=0; i < ALG_NUM_ALGS; i++) {
        global.algs[i] = (algorithm_t)i;
      }
    }
  } 

  /* -numiterations and -timelimit switch */
  if (SwitchPresent(pa,"-numiterations") && (SwitchPresent(pa,"-timelimit"))) {
    fprintf(stderr,"Error: Only one of -numiterations or -timelimit flags allowed\n");
    return -2;
  } else if (SwitchPresent(pa,"-numiterations")) {
    const char *numiterations_string=SwitchValueN(pa,"-numiterations",1,"0");
    if (*SwitchValueN(pa,"-numiterations",2,"")) {
      fprintf(stderr,"Error: Only one -numiterations flag allowed\n");
      return -2;
    }
    if (sscanf(numiterations_string,"%d",&(global.application.max_num_iterations)) != 1) {
      fprintf(stderr,"Error: Invalid -numiterations value\n");   
      return -2;
    }
    global.application.timelimit = -1;
  } else if (SwitchPresent(pa,"-timelimit")) {
    const char *timelimit_string=SwitchValueN(pa,"-timelimit",1,"0");
    if (*SwitchValueN(pa,"-timelimit",2,"")) {
      fprintf(stderr,"Error: Only one -timelimit flag allowed\n");
      return -2;
    }
    if (sscanf(timelimit_string,"%ld",&(global.application.timelimit)) != 1) {
      fprintf(stderr,"Error: Invalid -timelimit value\n");   
      return -2;
    }
    global.application.max_num_iterations = -1;
  } else {
    fprintf(stderr,"Error: One of -numiterations or -timelimit flags required\n");
    return -2;
  }

  /* -host switch */
  if (SwitchPresent(pa,"-host")) {
    int n=1;
    const char *host_string;
    global.platform.hosts = NULL;
    while (*(host_string = SwitchValueN(pa,"-host",n,""))) {
      global.platform.hosts = 
             (host_t **)realloc(global.platform.hosts,sizeof(host_t*)*n);

      if (instantiate_host(&(global.platform.hosts[n-1]),host_string)) {
        return -2;
      }
      global.platform.hosts[n-1]->id = n-1;
      n++;
    }
    global.platform.num_hosts = n-1;
  } else {
    fprintf(stderr,"Error: At least one -host flag is required\n");
    return -2;
  }

  return 0;
}

/* instantiate_host() */
static int instantiate_host(host_t **host, const char *host_spec)
{
  long endoftimes;
  char tracefile[512];
  long start_entry;

  *host = (host_t *)calloc(1,sizeof(host_t));

     /* Host based on a markov chain */
  if (sscanf(host_spec,"%d#%d#%ld#%lf#%lf#%lf#%lf#%lf#%lf#%lf#%lf#%lf",
                       &((*host)->w),
                       &((*host)->seed),
                       &(endoftimes),
		       &((*host)->chain.matrix[HOST_UP]        [HOST_UP]),
		       &((*host)->chain.matrix[HOST_UP]        [HOST_RECLAIMED]),
		       &((*host)->chain.matrix[HOST_UP]        [HOST_DOWN]),
		       &((*host)->chain.matrix[HOST_RECLAIMED] [HOST_UP]),
		       &((*host)->chain.matrix[HOST_RECLAIMED] [HOST_RECLAIMED]),
		       &((*host)->chain.matrix[HOST_RECLAIMED] [HOST_DOWN]),
		       &((*host)->chain.matrix[HOST_DOWN]      [HOST_UP]),
		       &((*host)->chain.matrix[HOST_DOWN]      [HOST_RECLAIMED]),
		       &((*host)->chain.matrix[HOST_DOWN]      [HOST_DOWN])) == 12) {
     if ((*host)->w <= 0) {
        fprintf(stderr,"Error: A host can't have a w-value equal to 0\n");
        return -1;
     }
 
    /* Compute the steady-state distribution */
    if (computePiDistribution(&((*host)->chain))) { 
      return -1;
    } 
    /* Associate a trace to the host */
    if (buildTraceFromChain((*host)->seed, endoftimes,
                global.distribution, global.distribution_shape,
                &((*host)->chain),&((*host)->availability))) {
      return -1;
    }
//    printTrace(&((*host)->availability));

    /* Host based on a trace */
  } else if (sscanf(host_spec,"%d#%ld#%s",&((*host)->w),&start_entry,tracefile) == 3) {
    if (parseTraceFile(tracefile, &((*host)->availability))) {
      return -1;
    }
    if (buildChainFromTrace(&((*host)->chain),&((*host)->availability))) {
      return -1;
    } 
    (*host)->availability.start_entry = 
            start_entry % ((*host)->availability.num_entries -1);
  } else {
    fprintf(stderr,"Error: Invalid host specification '%s'\n",host_spec);
    return -1;
  }

  /* Set the Pfanny value */
  (*host)->Pfanny = (*host)->chain.matrix[HOST_UP][HOST_UP] +
                    (*host)->chain.matrix[HOST_UP][HOST_RECLAIMED] *
                    (*host)->chain.matrix[HOST_RECLAIMED][HOST_UP] /
                    (1 - (*host)->chain.matrix[HOST_RECLAIMED][HOST_RECLAIMED]);
  (*host)->PUD_helper = 
     1.0 - ((*host)->chain.pi[HOST_UP] * (*host)->chain.matrix[HOST_UP][HOST_DOWN] +
     (*host)->chain.pi[HOST_RECLAIMED] * (*host)->chain.matrix[HOST_RECLAIMED][HOST_DOWN]) / ((*host)->chain.pi[HOST_UP] + (*host)->chain.pi[HOST_RECLAIMED]);

  (*host)->PLW_helper = (*host)->chain.matrix[HOST_UP][HOST_UP] +
                  (*host)->chain.matrix[HOST_UP][HOST_RECLAIMED] *
                  (*host)->chain.matrix[HOST_RECLAIMED][HOST_UP] /
                  (1 - (*host)->chain.matrix[HOST_RECLAIMED][HOST_RECLAIMED]);

  /* Initialize the counter of num_assigned_tasks */
  (*host)->num_assigned_tasks = 0;

  return 0;
}

/* print_scenario() */
static void print_scenario(void) 
{
  /* Print basic info */
  if (global.verbose >= 1) {
    fprintf(stderr,"%d tasks, %d iterations, ",
                       global.application.num_tasks,
                       global.application.max_num_iterations);
    if (global.application.mode == MODE_COUPLED) {
      fprintf(stderr,"coupled (Tprog=%d, Tdata=%d)\n",
              global.application.Tprog, global.application.Tdata);
    } else {
      fprintf(stderr,"independent (Tprog=%d, Tdata=%d)\n",
              global.application.Tprog, global.application.Tdata);
    }
    fprintf(stderr,"%d hosts, at most %d concurrent communications\n",
            global.platform.num_hosts, global.platform.max_num_comms);
  }

  /* Print detailed into */
  if (global.verbose >= 2) {
    int i;
    for (i=0; i < global.platform.num_hosts; i++) {
      fprintf(stderr,"host #%d (w=%d) (%d-entry trace, ending at time step %ld):\n",
                  i, global.platform.hosts[i]->w, 
                  global.platform.hosts[i]->availability.num_entries,
                  global.platform.hosts[i]->availability.dates[global.platform.hosts[i]->availability.num_entries-1]);
      printChain(&(global.platform.hosts[i]->chain));
      
    }
  }

  if (global.verbose >= 1) {
    fprintf(stderr,"========================================\n");
  }

  return;
}

/* print_simulation_output() */
static int print_simulation_output(algorithm_t alg)
{

  fprintf(stdout,"%s|%ld|%d|%.2f|%.2f|%.2f|%ld|%ld\n",
            algorithm_names[alg],
            global.current_date,
            global.application.num_completed_iterations,
            global.available_compute_power,
            global.used_compute_power,
            global.wasted_compute_power,
            global.comm_timesteps,
            global.comm_wasted_timesteps );

  return 0;
}

/* sanity_check() */
static int sanity_check() {

  /* Check that only indep/coupled algorithms are
     used for an indep/coupled simulation */
  if (global.application.mode == MODE_COUPLED) {
    int i;
    for (i=0; i < global.num_algs; i++) {
      // TODO: To complete
      if ((global.algs[i] == ALG_INDEP_MCT_v1)  ||
          (global.algs[i] == ALG_INDEP_MCT_v2)  ||
          (global.algs[i] == ALG_INDEP_UD_v1)   ||
          (global.algs[i] == ALG_INDEP_UD_v2)   ||
          (global.algs[i] == ALG_INDEP_EMCT_v1) ||
          (global.algs[i] == ALG_INDEP_EMCT_v2) ||
          (global.algs[i] == ALG_INDEP_EUD_v1)  ||
          (global.algs[i] == ALG_INDEP_EUD_v2)) {
        fprintf(stderr,"Algorithm %s is for independent mode only\n",
                       algorithm_names[i]);
        }
    }
  }

  if (global.application.mode == MODE_INDEPENDENT) {
    // TODO: To fill in
  }

  /* Check that if coupled no clones are allowed */
  if (global.application.mode == MODE_COUPLED) {
    if (global.max_num_clones > 0) {
      fprintf(stderr,"Can't have clones four a coupled application\n");
      return -1;
    }
  }

  /* Check that the number of clones makes sense */
  if (global.max_num_clones > global.platform.num_hosts -1) {
    fprintf(stderr,"Maximum number of clones too high\n");
    return -1;
  }

  return 0;
}
